## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
from CvPythonExtensions import *
import CvUtil
import ScreenInput
import CvScreenEnums
import string

# globals
gc = CyGlobalContext()
ArtFileMgr = CyArtFileMgr()
localText = CyTranslator()

class CvPediaBonus:
	"Civilopedia Screen for Bonus Resources"

	def __init__(self, main):
		self.iBonus = -1
		self.top = main

##--------	More Detailed Civilopedia: Modified by Denev 2009/09/18
		"""
		self.X_BONUS_PANE = 20
		self.Y_BONUS_PANE = 55
		self.W_BONUS_PANE = 433
		self.H_BONUS_PANE = 210

		self.X_BONUS_ANIMATION = 475
		self.Y_BONUS_ANIMATION = 63
		self.W_BONUS_ANIMATION = 303
		self.H_BONUS_ANIMATION = 200
		self.X_ROTATION_BONUS_ANIMATION = -20
		self.Z_ROTATION_BONUS_ANIMATION = 30
		self.SCALE_ANIMATION = 0.6

		self.X_ICON = 48
		self.Y_ICON = 90
		self.W_ICON = 150
		self.H_ICON = 150
		self.ICON_SIZE = 64

		self.X_STATS_PANE = 200
		self.Y_STATS_PANE = 150
		self.W_STATS_PANE = 240
		self.H_STATS_PANE = 200

		iWidthBuffer = 20
		iHeightBuffer = 0

		self.X_IMPROVEMENTS_PANE = 20
		self.Y_IMPROVEMENTS_PANE = self.Y_BONUS_PANE + self.H_BONUS_PANE + iHeightBuffer
		self.W_IMPROVEMENTS_PANE = 300
		self.H_IMPROVEMENTS_PANE = 110

		self.X_EFFECTS_PANE = self.X_IMPROVEMENTS_PANE + self.W_IMPROVEMENTS_PANE + iWidthBuffer
		self.Y_EFFECTS_PANE = self.Y_BONUS_PANE + self.H_BONUS_PANE + iHeightBuffer
		self.W_EFFECTS_PANE = 440
		self.H_EFFECTS_PANE = 110

		self.X_REQUIRES = 20
		self.Y_REQUIRES = self.Y_IMPROVEMENTS_PANE + self.H_IMPROVEMENTS_PANE + iHeightBuffer
		self.W_REQUIRES = 300
		self.H_REQUIRES = 110

		self.X_HISTORY_PANE = self.X_REQUIRES + self.W_REQUIRES + iWidthBuffer
		self.Y_HISTORY_PANE = self.Y_EFFECTS_PANE + self.H_EFFECTS_PANE + iHeightBuffer
		self.W_HISTORY_PANE = 440
		self.H_HISTORY_PANE = 220

		self.X_BUILDINGS = 20
		self.Y_BUILDINGS = self.Y_REQUIRES + self.H_REQUIRES + iHeightBuffer
		self.W_BUILDINGS = 300
		self.H_BUILDINGS = 110

		self.X_ALLOWS_PANE = 20
		self.Y_ALLOWS_PANE = self.Y_BUILDINGS + self.H_BUILDINGS + iHeightBuffer
		self.W_ALLOWS_PANE = 760
		self.H_ALLOWS_PANE = 110
		"""
		X_MERGIN = self.top.X_MERGIN
#		Y_MERGIN = self.top.Y_MERGIN
		Y_MERGIN = 0

		self.X_MAIN_PANE = self.top.X_PEDIA_PAGE
		self.Y_MAIN_PANE = self.top.Y_PEDIA_PAGE
		self.W_MAIN_PANE = 436
		self.H_MAIN_PANE = 210

		self.W_ICON = 150
		self.H_ICON = 150
		self.X_ICON = self.X_MAIN_PANE + (self.H_MAIN_PANE - self.H_ICON) / 2
		self.Y_ICON = self.Y_MAIN_PANE + (self.H_MAIN_PANE - self.H_ICON) / 2
		self.ICON_SIZE = 64

		self.X_BONUS_ANIMATION = self.X_MAIN_PANE + self.W_MAIN_PANE + X_MERGIN
		self.Y_BONUS_ANIMATION = self.Y_MAIN_PANE + 7
		self.W_BONUS_ANIMATION = self.top.R_PEDIA_PAGE - self.X_BONUS_ANIMATION
		self.H_BONUS_ANIMATION = self.H_MAIN_PANE - 7
		self.X_ROTATION_BONUS_ANIMATION = -20
		self.Z_ROTATION_BONUS_ANIMATION = 30
		self.SCALE_ANIMATION = 0.6

		self.X_STATUS = self.X_ICON + self.W_ICON + 10
		self.Y_STATUS = self.Y_ICON
		self.W_STATUS = self.X_MAIN_PANE + self.W_MAIN_PANE - self.X_STATUS
		self.H_STATUS = self.Y_MAIN_PANE + self.H_MAIN_PANE - self.Y_STATUS

		self.X_REQUIRES = self.X_MAIN_PANE
		self.Y_REQUIRES = self.Y_MAIN_PANE + self.H_MAIN_PANE + Y_MERGIN
		self.W_REQUIRES = 300
		self.H_REQUIRES = 110

		self.X_ALLOWS = self.X_REQUIRES + self.W_REQUIRES + X_MERGIN
		self.Y_ALLOWS = self.Y_REQUIRES
		self.W_ALLOWS = self.top.R_PEDIA_PAGE - self.X_ALLOWS
		self.H_ALLOWS = self.H_REQUIRES

		self.X_IMPROVEMENTS = self.X_REQUIRES
		self.Y_IMPROVEMENTS = self.Y_REQUIRES + self.H_REQUIRES + Y_MERGIN
		self.W_IMPROVEMENTS = self.W_REQUIRES
		self.H_IMPROVEMENTS = 110

		self.X_BUILDINGS = self.X_IMPROVEMENTS + self.W_IMPROVEMENTS + X_MERGIN
		self.Y_BUILDINGS = self.Y_IMPROVEMENTS
		self.W_BUILDINGS = self.W_ALLOWS
		self.H_BUILDINGS = self.H_IMPROVEMENTS

		self.X_EFFECTS = self.X_IMPROVEMENTS
		self.Y_EFFECTS = self.Y_IMPROVEMENTS + self.H_IMPROVEMENTS + Y_MERGIN
		self.W_EFFECTS = self.W_IMPROVEMENTS
		self.H_EFFECTS = self.top.B_PEDIA_PAGE - self.Y_EFFECTS

		self.X_HISTORY = self.X_EFFECTS + self.W_EFFECTS + X_MERGIN
		self.Y_HISTORY = self.Y_EFFECTS
		self.W_HISTORY = self.W_BUILDINGS
		self.H_HISTORY = self.H_EFFECTS
##--------	More Detailed Civilopedia: End Modify

	# Screen construction function
	def interfaceScreen(self, iBonus):

		self.iBonus = iBonus

		self.top.deleteAllWidgets()

		screen = self.top.getScreen()

		bNotActive = (not screen.isActive())
		if bNotActive:
			self.top.setPediaCommonWidgets()

		# Header...
		szHeader = u"<font=4b>" + gc.getBonusInfo(self.iBonus).getDescription().upper() + u"</font>"
		szHeaderId = self.top.getNextWidgetName()
		screen.setLabel(szHeaderId, "Background", szHeader, CvUtil.FONT_CENTER_JUSTIFY, self.top.X_SCREEN, self.top.Y_TITLE, 0, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_GENERAL, CivilopediaPageTypes.CIVILOPEDIA_PAGE_BONUS, iBonus)

		# Top
		screen.setText(self.top.getNextWidgetName(), "Background", self.top.MENU_TEXT, CvUtil.FONT_LEFT_JUSTIFY, self.top.X_MENU, self.top.Y_MENU, 0, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_PEDIA_MAIN, CivilopediaPageTypes.CIVILOPEDIA_PAGE_BONUS, -1)

		if self.top.iLastScreen	!= CvScreenEnums.PEDIA_BONUS or bNotActive:
			self.placeLinks(true)
			self.top.iLastScreen = CvScreenEnums.PEDIA_BONUS
		else:
			self.placeLinks(false)

		# Icon
		screen.addPanel( self.top.getNextWidgetName(), "", "", False, False,
			self.X_MAIN_PANE, self.Y_MAIN_PANE, self.W_MAIN_PANE, self.H_MAIN_PANE, PanelStyles.PANEL_STYLE_BLUE50)
		screen.addPanel(self.top.getNextWidgetName(), "", "", false, false,
			self.X_ICON, self.Y_ICON, self.W_ICON, self.H_ICON, PanelStyles.PANEL_STYLE_MAIN)
		screen.addDDSGFC(self.top.getNextWidgetName(), gc.getBonusInfo(self.iBonus).getButton(),
			self.X_ICON + self.W_ICON/2 - self.ICON_SIZE/2, self.Y_ICON + self.H_ICON/2 - self.ICON_SIZE/2, self.ICON_SIZE, self.ICON_SIZE, WidgetTypes.WIDGET_GENERAL, -1, -1 )

		# Bonus animation
		screen.addBonusGraphicGFC(self.top.getNextWidgetName(), self.iBonus,
			self.X_BONUS_ANIMATION, self.Y_BONUS_ANIMATION, self.W_BONUS_ANIMATION, self.H_BONUS_ANIMATION, WidgetTypes.WIDGET_GENERAL, -1, -1, self.X_ROTATION_BONUS_ANIMATION, self.Z_ROTATION_BONUS_ANIMATION, self.SCALE_ANIMATION, True)

		self.placeStats()

		self.placeYield()

		self.placeRequires()

		self.placeBuildings()
		self.placeAllows()

		self.placeSpecial()

		self.placeHistory()

		return

	def placeStats(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addListBoxGFC(panelName, "", self.X_STATUS, self.Y_STATUS, self.W_STATUS, self.H_STATUS, TableStyles.TABLE_STYLE_EMPTY)
		screen.enableSelect(panelName, False)

##--------	More Detailed Civilopedia: Added by Denev 2009/09/23
		szTitle = u"<font=4>" + localText.getText("TXT_KEY_BONUS_TILE_MODIFIER", ()).upper() + u"<font>"
		screen.appendListBoxString(panelName, szTitle, WidgetTypes.WIDGET_GENERAL, 0, 0, CvUtil.FONT_LEFT_JUSTIFY)

		bEffect = false
##--------	More Detailed Civilopedia: End Add
		for k in range(YieldTypes.NUM_YIELD_TYPES):
			iYieldChange = gc.getBonusInfo(self.iBonus).getYieldChange(k)
			if (iYieldChange != 0):
				if (iYieldChange > 0):
					sign = "+"
				else:
					sign = ""

				szYield = (u"%s: %s%i " % (gc.getYieldInfo(k).getDescription(), sign, iYieldChange))
				screen.appendListBoxString(panelName, u"<font=4>" + szYield.upper() + (u"%c" % gc.getYieldInfo(k).getChar()) + u"</font>", WidgetTypes.WIDGET_GENERAL, 0, 0, CvUtil.FONT_LEFT_JUSTIFY)
##--------	More Detailed Civilopedia: Added by Denev 2009/09/23
				bEffect = true
		if not bEffect:
			screen.hide(panelName)
##--------	More Detailed Civilopedia: End Add

	def placeYield(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
		"""
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_CATEGORY_IMPROVEMENT", ()), "", true, true,
				 self.X_IMPROVEMENTS, self.Y_IMPROVEMENTS, self.W_IMPROVEMENTS, self.H_IMPROVEMENTS, PanelStyles.PANEL_STYLE_BLUE50 )
		"""
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_CATEGORY_IMPROVEMENT", ()), "", false, true,
				 self.X_IMPROVEMENTS, self.Y_IMPROVEMENTS, self.W_IMPROVEMENTS, self.H_IMPROVEMENTS, PanelStyles.PANEL_STYLE_BLUE50 )
##--------	More Detailed Civilopedia: End Modify

		bonusInfo = gc.getBonusInfo(self.iBonus)

		for j in range(gc.getNumImprovementInfos()):
			bFirst = True
			szYield = u""
			bEffect = False
			for k in range(YieldTypes.NUM_YIELD_TYPES):
				iYieldChange = gc.getImprovementInfo(j).getImprovementBonusYield(self.iBonus, k)
				if (iYieldChange != 0):
					bEffect = True
					iYieldChange += gc.getImprovementInfo(j).getYieldChange(k)

					if (bFirst):
						bFirst = False
					else:
						szYield += ", "

					if (iYieldChange > 0):
						sign = "+"
					else:
						sign = ""

##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
#					szYield += (u"%s%i%c" % (sign, iYieldChange, gc.getYieldInfo(k).getChar()))
					szYield += (u"<font=3>%s%i%c</font>" % (sign, iYieldChange, gc.getYieldInfo(k).getChar()))
##--------	More Detailed Civilopedia: End Modify

##--------	More Detailed Civilopedia: Added by Denev 2009/09/23
				"Mana Nodes and World Improvements"
				if gc.getImprovementInfo(j).getBonusConvert() == self.iBonus:
					bEffect = True
##--------	More Detailed Civilopedia: End Add

			if (bEffect):
				childPanelName = self.top.getNextWidgetName()
				screen.attachPanel(panelName, childPanelName, "", "", False, False, PanelStyles.PANEL_STYLE_EMPTY)

				screen.attachLabel(childPanelName, "", "  ")
				screen.attachImageButton(childPanelName, "", gc.getImprovementInfo(j).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_IMPROVEMENT, j, 1, False )
				screen.attachLabel(childPanelName, "", szYield)

	def placeSpecial(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_EFFECTS", ()), "", true, false,
				 self.X_EFFECTS, self.Y_EFFECTS, self.W_EFFECTS, self.H_EFFECTS, PanelStyles.PANEL_STYLE_BLUE50 )

		listName = self.top.getNextWidgetName()
		screen.attachListBoxGFC( panelName, listName, "", TableStyles.TABLE_STYLE_EMPTY )
		screen.enableSelect(listName, False)

		szSpecialText = CyGameTextMgr().getBonusHelp(self.iBonus, True)
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
		"""
		splitText = string.split( szSpecialText, "\n" )
		for special in splitText:
			if len( special ) != 0:
				screen.appendListBoxString( listName, special, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY )
		"""
		szSpecialText = szSpecialText.strip("\n")	#trim empty lines
		screen.addMultilineText( listName, szSpecialText, self.X_EFFECTS + 5, self.Y_EFFECTS + 30, self.W_EFFECTS - 5, self.H_EFFECTS - 32, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
##--------	More Detailed Civilopedia: End Modify

	def placeRequires(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_REQUIRES", ()), "", false, true,
				 self.X_REQUIRES, self.Y_REQUIRES, self.W_REQUIRES, self.H_REQUIRES, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		iTech = gc.getBonusInfo(self.iBonus).getTechReveal()
		if (iTech > -1):
			screen.attachImageButton( panelName, "", gc.getTechInfo(iTech).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_TECH, iTech, 1, False )
			screen.attachLabel(panelName, "", u"(" + localText.getText("TXT_KEY_PEDIA_BONUS_APPEARANCE", ()) + u")")
		iTech = gc.getBonusInfo(self.iBonus).getTechCityTrade()
		if (iTech > -1):
			screen.attachImageButton( panelName, "", gc.getTechInfo(iTech).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_TECH, iTech, 1, False )
			screen.attachLabel(panelName, "", u"(" + localText.getText("TXT_KEY_PEDIA_BONUS_TRADE", ()) + u")")

	def placeHistory(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_CIVILOPEDIA_HISTORY", ()), "", True, True,
			self.X_HISTORY, self.Y_HISTORY, self.W_HISTORY, self.H_HISTORY, PanelStyles.PANEL_STYLE_BLUE50)

		screen.attachLabel(panelName, "", "  ")

		textName = self.top.getNextWidgetName()
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
		"""
		screen.addMultilineText( textName, gc.getBonusInfo(self.iBonus).getCivilopedia(), self.X_HISTORY_PANE + 15, self.Y_HISTORY_PANE + 40,
			self.W_HISTORY_PANE - (15 * 2), self.H_HISTORY_PANE - (15 * 2) - 25, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
		"""
		screen.addMultilineText( textName, gc.getBonusInfo(self.iBonus).getCivilopedia(),
			self.X_HISTORY + 5, self.Y_HISTORY + 30, self.W_HISTORY - 5, self.H_HISTORY - 32, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
##--------	More Detailed Civilopedia: End Modify

	def placeBuildings(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
#		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_CATEGORY_BUILDING", ()), "", false, true, self.X_BUILDINGS, self.Y_BUILDINGS, self.W_BUILDINGS, self.H_BUILDINGS, PanelStyles.PANEL_STYLE_BLUE50 )
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_PRODUCING_BUILDINGS", ()), "", false, true, self.X_BUILDINGS, self.Y_BUILDINGS, self.W_BUILDINGS, self.H_BUILDINGS, PanelStyles.PANEL_STYLE_BLUE50 )
##--------	More Detailed Civilopedia: End Modify

		screen.attachLabel(panelName, "", "  ")

		for iBuilding in range(gc.getNumBuildingInfos()):
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
#			if (gc.getBuildingInfo(iBuilding).getFreeBonus() == self.iBonus):
			liFreeBonus = [	gc.getBuildingInfo(iBuilding).getFreeBonus(),
							gc.getBuildingInfo(iBuilding).getFreeBonus2(),
							gc.getBuildingInfo(iBuilding).getFreeBonus3()]
			if self.iBonus in liFreeBonus:
##--------	More Detailed Civilopedia: End Modify
				screen.attachImageButton( panelName, "", gc.getBuildingInfo(iBuilding).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BUILDING, iBuilding, 1, False )

	def placeAllows(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_ALLOWS", ()), "", false, true,
				 self.X_ALLOWS, self.Y_ALLOWS, self.W_ALLOWS, self.H_ALLOWS, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		# add unit buttons
		for eLoopUnit in range(gc.getNumUnitInfos()):
			bFound = False
			if (eLoopUnit >= 0):
				if (gc.getUnitInfo(eLoopUnit).getPrereqAndBonus() == self.iBonus):
					bFound = True
				else:
					j = 0
					while (not bFound and j < gc.getNUM_UNIT_PREREQ_OR_BONUSES()):
						if (gc.getUnitInfo(eLoopUnit).getPrereqOrBonuses(j) == self.iBonus):
							bFound = True
						j += 1
			if bFound:
				szButton = gc.getUnitInfo(eLoopUnit).getButton()
				if self.top.iActivePlayer != -1:
					szButton = gc.getPlayer(self.top.iActivePlayer).getUnitButton(eLoopUnit)
				screen.attachImageButton( panelName, "", szButton, GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_UNIT, eLoopUnit, 1, False )

		# add building buttons
		for eLoopBuilding in range(gc.getNumBuildingInfos()):
			bFound = False
			if (gc.getBuildingInfo(eLoopBuilding).getPrereqAndBonus() == self.iBonus):
				bFound = True
			else:
				j = 0
				while (not bFound and j < gc.getNUM_BUILDING_PREREQ_OR_BONUSES()):
					if (gc.getBuildingInfo(eLoopBuilding).getPrereqOrBonuses(j) == self.iBonus):
						bFound = True
					j += 1
			if bFound:
				screen.attachImageButton( panelName, "", gc.getBuildingInfo(eLoopBuilding).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BUILDING, eLoopBuilding, 1, False )

##--------	More Detailed Civilopedia: Added by Denev 2009/10/03
		# add promotion buttons
		for eLoopPromotion in range(gc.getNumPromotionInfos()):
			bFound = False
			if (gc.getPromotionInfo(eLoopPromotion).getBonusPrereq() == self.iBonus):
				screen.attachImageButton( panelName, "", gc.getPromotionInfo(eLoopPromotion).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_PROMOTION, eLoopPromotion, 1, False )
##--------	More Detailed Civilopedia: End Add

	def placeLinks(self, bRedraw):

		screen = self.top.getScreen()

		if bRedraw:
			screen.clearListBoxGFC(self.top.LIST_ID)

		# sort resources alphabetically
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/19
		"""
		rowListName=[(0,0)]*gc.getNumBonusInfos()
		for j in range(gc.getNumBonusInfos()):
			rowListName[j] = (gc.getBonusInfo(j).getDescription(), j)
		rowListName.sort()

		iSelected = 0
		i = 0
		for iI in range(gc.getNumBonusInfos()):
			if (not gc.getBonusInfo(rowListName[iI][1]).isGraphicalOnly()):
				if bRedraw:
					screen.appendListBoxString(self.top.LIST_ID, rowListName[iI][0], WidgetTypes.WIDGET_PEDIA_JUMP_TO_BONUS, rowListName[iI][1], 0, CvUtil.FONT_LEFT_JUSTIFY )
				if rowListName[iI][1] == self.iBonus:
					iSelected = i
				i += 1
		"""
		listSorted = self.top.getSortedList( gc.getNumBonusInfos(), gc.getBonusInfo )

		iSelected = 0
		for iIndex, (szIndexName, iBonus, szDescription) in enumerate(listSorted):
			if not gc.getBonusInfo(iBonus).isGraphicalOnly():
				if bRedraw:
					screen.appendListBoxString(self.top.LIST_ID, szDescription, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BONUS, iBonus, 0, CvUtil.FONT_LEFT_JUSTIFY)
				if iBonus == self.iBonus:
					iSelected = iIndex
##--------	More Detailed Civilopedia: End Modify

		screen.setSelectedListBoxStringGFC(self.top.LIST_ID, iSelected)

	# Will handle the input for this screen...
	def handleInput (self, inputClass):
		return 0


