## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
from CvPythonExtensions import *
import CvUtil
import ScreenInput
import CvScreenEnums
import string

# globals
gc = CyGlobalContext()
ArtFileMgr = CyArtFileMgr()
localText = CyTranslator()

class CvPediaReligion:
	"Civilopedia Screen for Religions"

	def __init__(self, main):
		self.iReligion = -1
		self.top = main

##--------	More Detailed Civilopedia: Modified by Denev 2009/09/30
		"""
		self.X_MAIN_PANE = 50
		self.Y_MAIN_PANE = 90
		self.W_MAIN_PANE = 250
		self.H_MAIN_PANE = 210

		self.X_ICON = 98
		self.Y_ICON = 125
		self.W_ICON = 150
		self.H_ICON = 150
		self.ICON_SIZE = 64

		self.X_REQUIRES = 330
		self.Y_REQUIRES = 70
		self.W_REQUIRES = 425
		self.H_REQUIRES = 110

		self.X_SPECIAL = 330
		self.Y_SPECIAL = 190
		self.W_SPECIAL = 425
		self.H_SPECIAL = 110

		self.X_TEXT = self.X_MAIN_PANE
		self.Y_TEXT = self.Y_MAIN_PANE + self.H_MAIN_PANE + 20
		self.W_TEXT = 705
		self.H_TEXT = 350
		"""
		X_MERGIN = self.top.X_MERGIN
		Y_MERGIN = self.top.Y_MERGIN

		self.X_MAIN_PANE = self.top.X_PEDIA_PAGE
		self.Y_MAIN_PANE = self.top.Y_PEDIA_PAGE
		self.W_MAIN_PANE = 368
		self.H_MAIN_PANE = 210

		self.W_ICON = 150
		self.H_ICON = 150
		self.X_ICON = self.X_MAIN_PANE + (self.H_MAIN_PANE - self.H_ICON) / 2
		self.Y_ICON = self.Y_MAIN_PANE + (self.H_MAIN_PANE - self.H_ICON) / 2
		self.ICON_SIZE = 64

		self.X_STATUS = self.X_ICON + self.W_ICON + 10
		self.Y_STATUS = self.Y_ICON + 50
		self.W_STATUS = self.X_MAIN_PANE + self.W_MAIN_PANE - self.X_STATUS
		self.H_STATUS = self.Y_MAIN_PANE + self.H_MAIN_PANE - self.Y_STATUS

		self.H_GLOBALS = 110
		self.X_GLOBALS = self.X_MAIN_PANE + self.W_MAIN_PANE + X_MERGIN
		self.Y_GLOBALS = self.Y_MAIN_PANE + self.H_MAIN_PANE - self.H_GLOBALS
		self.W_GLOBALS = self.top.R_PEDIA_PAGE - self.X_GLOBALS

		self.H_REQUIRES = 110
		self.X_REQUIRES = self.X_GLOBALS
		self.Y_REQUIRES = self.Y_GLOBALS - self.H_REQUIRES - Y_MERGIN
		self.W_REQUIRES = self.W_GLOBALS

		self.X_BUILDINGS = self.X_MAIN_PANE
		self.Y_BUILDINGS = self.Y_MAIN_PANE + self.H_MAIN_PANE + Y_MERGIN
		self.W_BUILDINGS = self.W_MAIN_PANE
		self.H_BUILDINGS = 110

		self.X_UNITS = self.X_BUILDINGS + self.W_BUILDINGS + X_MERGIN
		self.Y_UNITS = self.Y_BUILDINGS
		self.W_UNITS = self.top.R_PEDIA_PAGE - self.X_UNITS
		self.H_UNITS = self.H_BUILDINGS

		self.X_OTHERS = self.X_BUILDINGS
		self.Y_OTHERS = self.Y_BUILDINGS + self.H_BUILDINGS + Y_MERGIN
		self.W_OTHERS = self.W_BUILDINGS
		self.H_OTHERS = 110

		self.X_SPECIAL = self.X_OTHERS
		self.Y_SPECIAL = self.Y_OTHERS + self.H_OTHERS + Y_MERGIN
		self.W_SPECIAL = self.W_OTHERS
		self.H_SPECIAL = self.top.B_PEDIA_PAGE - self.Y_SPECIAL

		self.X_TEXT = self.X_UNITS
		self.Y_TEXT = self.Y_UNITS + self.H_UNITS + Y_MERGIN
		self.W_TEXT = self.W_UNITS
		self.H_TEXT = self.top.B_PEDIA_PAGE - self.Y_TEXT
##--------	More Detailed Civilopedia: End Modify

	# Screen construction function
	def interfaceScreen(self, iReligion):

		self.iReligion = iReligion

		self.top.deleteAllWidgets()

		screen = self.top.getScreen()

		bNotActive = (not screen.isActive())
		if bNotActive:
			self.top.setPediaCommonWidgets()

		# Header...
		szHeader = u"<font=4b>" + gc.getReligionInfo(self.iReligion).getDescription().upper() + u"</font>"
		szHeaderId = self.top.getNextWidgetName()
		screen.setLabel(szHeaderId, "Background", szHeader, CvUtil.FONT_CENTER_JUSTIFY, self.top.X_SCREEN, self.top.Y_TITLE, 0, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1)

		# Top
		screen.setText(self.top.getNextWidgetName(), "Background", self.top.MENU_TEXT, CvUtil.FONT_LEFT_JUSTIFY, self.top.X_MENU, self.top.Y_MENU, 0, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_PEDIA_MAIN, CivilopediaPageTypes.CIVILOPEDIA_PAGE_RELIGION, -1)

		if self.top.iLastScreen	!= CvScreenEnums.PEDIA_RELIGION or bNotActive:
			self.placeLinks(true)
			self.top.iLastScreen = CvScreenEnums.PEDIA_RELIGION
		else:
			self.placeLinks(false)

		# Icon
		screen.addPanel( self.top.getNextWidgetName(), "", "", False, False,
			self.X_MAIN_PANE, self.Y_MAIN_PANE, self.W_MAIN_PANE, self.H_MAIN_PANE, PanelStyles.PANEL_STYLE_BLUE50)
		screen.addPanel(self.top.getNextWidgetName(), "", "", false, false,
			self.X_ICON, self.Y_ICON, self.W_ICON, self.H_ICON, PanelStyles.PANEL_STYLE_MAIN)
		screen.addDDSGFC(self.top.getNextWidgetName(), gc.getReligionInfo(self.iReligion).getButton(),
			self.X_ICON + self.W_ICON/2 - self.ICON_SIZE/2, self.Y_ICON + self.H_ICON/2 - self.ICON_SIZE/2, self.ICON_SIZE, self.ICON_SIZE, WidgetTypes.WIDGET_GENERAL, -1, -1 )

		self.placeSpecial()
		self.placeRequires()
		self.placeText()
##--------	More Detailed Civilopedia: Added by Denev 2009/09/30
		self.placeGlobals()
		self.placeUnits()
		self.placeBuildings()
		self.placeItemsToFollowers()

	def placeGlobals(self):
		screen = self.top.getScreen()
		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_HEROES_OR_WONDERS_ENABLED", ()), "", false, true, self.X_GLOBALS, self.Y_GLOBALS, self.W_GLOBALS, self.H_GLOBALS, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		for iLoopUnit in range(gc.getNumUnitInfos()):
			if isWorldUnitClass(gc.getUnitInfo(iLoopUnit).getUnitClassType())\
			and gc.getUnitInfo(iLoopUnit).getStateReligion() == self.iReligion:
				szButton = gc.getUnitInfo(iLoopUnit).getButton()
				if self.top.iActivePlayer != PlayerTypes.NO_PLAYER:
					szButton = gc.getPlayer(self.top.iActivePlayer).getUnitButton(iLoopUnit)
				screen.attachImageButton( panelName, "", szButton, GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_UNIT, iLoopUnit, 1, False )

		for iLoopBuilding in range(gc.getNumBuildingInfos()):
			if isWorldWonderClass(gc.getBuildingInfo(iLoopBuilding).getBuildingClassType())\
			and gc.getBuildingInfo(iLoopBuilding).getStateReligion() == self.iReligion:
				screen.attachImageButton( panelName, "", gc.getBuildingInfo(iLoopBuilding).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BUILDING, iLoopBuilding, 1, False )

	def placeUnits(self):
		screen = self.top.getScreen()
		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_UNITS_ENABLED", ()), "", false, true, self.X_UNITS, self.Y_UNITS, self.W_UNITS, self.H_UNITS, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		for iLoopUnit in range(gc.getNumUnitInfos()):
			if gc.getUnitInfo(iLoopUnit).getStateReligion() == self.iReligion\
			and not isWorldUnitClass(gc.getUnitInfo(iLoopUnit).getUnitClassType()):
				szButton = gc.getUnitInfo(iLoopUnit).getButton()
				if self.top.iActivePlayer != PlayerTypes.NO_PLAYER:
					szButton = gc.getPlayer(self.top.iActivePlayer).getUnitButton(iLoopUnit)
				screen.attachImageButton( panelName, "", szButton, GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_UNIT, iLoopUnit, 1, False )

	def placeBuildings(self):
		screen = self.top.getScreen()
		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_OTHERS_ENABLED", ()), "", false, true, self.X_BUILDINGS, self.Y_BUILDINGS, self.W_BUILDINGS, self.H_BUILDINGS, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		for iLoopTech in range(gc.getNumTechInfos()):
			if gc.getTechInfo(iLoopTech).getPrereqReligion() == self.iReligion:
				screen.attachImageButton( panelName, "", gc.getTechInfo(iLoopTech).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_TECH, iLoopTech, 1, False )

		for iLoopBuilding in range(gc.getNumBuildingInfos()):
			if gc.getBuildingInfo(iLoopBuilding).getStateReligion() == self.iReligion\
			and not isWorldWonderClass(gc.getBuildingInfo(iLoopBuilding).getBuildingClassType()):
				screen.attachImageButton( panelName, "", gc.getBuildingInfo(iLoopBuilding).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BUILDING, iLoopBuilding, 1, False )

		for iLoopCivic in range(gc.getNumCivicInfos()):
			if gc.getCivicInfo(iLoopCivic).getPrereqReligion() == self.iReligion:
				screen.attachImageButton( panelName, "", gc.getCivicInfo(iLoopCivic).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_CIVIC, iLoopCivic, 1, False )

		for iLoopFeature in range(gc.getNumFeatureInfos()):
			if gc.getFeatureInfo(iLoopFeature).getPrereqStateReligion() == self.iReligion:
				screen.attachImageButton( panelName, "", gc.getFeatureInfo(iLoopFeature).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_FEATURE, iLoopFeature, 1, False )

		for iLoopSpell in range(gc.getNumSpellInfos()):
			if gc.getSpellInfo(iLoopSpell).getStateReligionPrereq() == self.iReligion:
				screen.attachImageButton( panelName, "", gc.getSpellInfo(iLoopSpell).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_SPELL, iLoopSpell, 1, False )

		for iLoopPromotion in range(gc.getNumPromotionInfos()):
			if gc.getPromotionInfo(iLoopPromotion).getStateReligionPrereq() == self.iReligion:
				screen.attachImageButton( panelName, "", gc.getPromotionInfo(iLoopPromotion).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_PROMOTION, iLoopPromotion, 1, False )

	def placeItemsToFollowers(self):
		screen = self.top.getScreen()
		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_ENABLED_WITHOUT_STATE", ()), "", false, true, self.X_OTHERS, self.Y_OTHERS, self.W_OTHERS, self.H_OTHERS, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		for iLoopUnit in range(gc.getNumUnitInfos()):
			if gc.getUnitInfo(iLoopUnit).getPrereqReligion() == self.iReligion\
			and gc.getUnitInfo(iLoopUnit).getStateReligion() == ReligionTypes.NO_RELIGION:
				szButton = gc.getUnitInfo(iLoopUnit).getButton()
				if self.top.iActivePlayer != PlayerTypes.NO_PLAYER:
					szButton = gc.getPlayer(self.top.iActivePlayer).getUnitButton(iLoopUnit)
				screen.attachImageButton( panelName, "", szButton, GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_UNIT, iLoopUnit, 1, False )

		for iLoopBuilding in range(gc.getNumBuildingInfos()):
			if gc.getBuildingInfo(iLoopBuilding).getPrereqReligion() == self.iReligion\
			and gc.getBuildingInfo(iLoopBuilding).getStateReligion() == ReligionTypes.NO_RELIGION:
				screen.attachImageButton( panelName, "", gc.getBuildingInfo(iLoopBuilding).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BUILDING, iLoopBuilding, 1, False )

		for iLoopSpell in range(gc.getNumSpellInfos()):
			if gc.getSpellInfo(iLoopSpell).getReligionPrereq() == self.iReligion\
			and gc.getSpellInfo(iLoopSpell).getStateReligionPrereq() == ReligionTypes.NO_RELIGION:
				screen.attachImageButton( panelName, "", gc.getSpellInfo(iLoopSpell).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_SPELL, iLoopSpell, 1, False )
##--------	More Detailed Civilopedia: End Add

	def placeRequires(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
##--------	More Detailed Civilopedia: Modified by Denev 2009/10/03
#		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_REQUIRES", ()), "", false, true,
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_FOUNDED_BY_FIRST", ()), "", false, true,
##--------	More Detailed Civilopedia: End Modify
				 self.X_REQUIRES, self.Y_REQUIRES, self.W_REQUIRES, self.H_REQUIRES, PanelStyles.PANEL_STYLE_BLUE50 )
		screen.attachLabel(panelName, "", "  ")

		iTech = gc.getReligionInfo(self.iReligion).getTechPrereq()
		if (iTech > -1):
			screen.attachImageButton( panelName, "", gc.getTechInfo(iTech).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_TECH, iTech, 1, False )

	def placeSpecial(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_EFFECTS", ()), "", true, false,
				 self.X_SPECIAL, self.Y_SPECIAL, self.W_SPECIAL, self.H_SPECIAL, PanelStyles.PANEL_STYLE_BLUE50 )

		listName = self.top.getNextWidgetName()
		screen.attachListBoxGFC( panelName, listName, "", TableStyles.TABLE_STYLE_EMPTY )
		screen.enableSelect(listName, False)

		szSpecialText = CyGameTextMgr().parseReligionInfo(self.iReligion, True)
##--------	More Detailed Civilopedia: Modified by Denev 2009/10/01
		"""
		splitText = string.split( szSpecialText, "\n" )
		for special in splitText:
			if len( special ) != 0:
				screen.appendListBoxString( listName, special, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY )
		"""
		szSpecialText = szSpecialText.strip("\n")	#Trim empty line
		screen.addMultilineText(listName, szSpecialText, self.X_SPECIAL + 5, self.Y_SPECIAL + 30, self.W_SPECIAL - 5, self.H_SPECIAL - 32, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
##--------	More Detailed Civilopedia: End Modify

	def placeText(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_CIVILOPEDIA_HISTORY", ()), "", true, true,
				 self.X_TEXT, self.Y_TEXT, self.W_TEXT, self.H_TEXT, PanelStyles.PANEL_STYLE_BLUE50 )

		szText = gc.getReligionInfo(self.iReligion).getCivilopedia()
		screen.attachMultilineText( panelName, "Text", szText, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)

	def placeLinks(self, bRedraw):

		screen = self.top.getScreen()

		if bRedraw:
			screen.clearListBoxGFC(self.top.LIST_ID)

		# sort Improvements alphabetically
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/30
		"""
		listSorted=[(0,0)]*gc.getNumReligionInfos()
		for j in range(gc.getNumReligionInfos()):
			listSorted[j] = (gc.getReligionInfo(j).getDescription(), j)
		listSorted.sort()

		iSelected = 0
		i = 0
		for iI in range(gc.getNumReligionInfos()):
			if (not gc.getReligionInfo(listSorted[iI][1]).isGraphicalOnly()):
				if bRedraw:
					screen.appendListBoxString( self.top.LIST_ID, listSorted[iI][0], WidgetTypes.WIDGET_PEDIA_JUMP_TO_RELIGION, listSorted[iI][1], 0, CvUtil.FONT_LEFT_JUSTIFY )
				if listSorted[iI][1] == self.iReligion:
					iSelected = i
				i += 1
		"""
		listSorted = self.top.getSortedList( gc.getNumReligionInfos(), gc.getReligionInfo )

		iSelected = 0
		for iIndex, (szIndexName, iReligion, szDescription) in enumerate(listSorted):
			if not gc.getReligionInfo(iReligion).isGraphicalOnly():
				if bRedraw:
					screen.appendListBoxString(self.top.LIST_ID, szDescription, WidgetTypes.WIDGET_PEDIA_JUMP_TO_RELIGION, iReligion, 0, CvUtil.FONT_LEFT_JUSTIFY)
				if iReligion == self.iReligion:
					iSelected = iIndex
##--------	More Detailed Civilopedia: End Modify

		screen.setSelectedListBoxStringGFC(self.top.LIST_ID, iSelected)

	# Will handle the input for this screen...
	def handleInput (self, inputClass):
		return 0


