## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
# Sid Meier's Civilization 4
# Copyright Firaxis Games 2005
#
# CvScreen - Base class for all of the Screens

from CvPythonExtensions import *
import CvUtil
import CvScreen
##--------	More Detailed Civilopedia: Added by Denev 2009/09/25
import random
gc = CyGlobalContext()
##--------	More Detailed Civilopedia: End Added

class CvPediaScreen( CvScreen.CvScreen ):
	"Civilopedia Base Screen"

##--------	More Detailed Civilopedia: Modified by Denev 2009/09/21
#	def getSortedList( self, numInfos, getInfo ):
	def getSortedList( self, numInfos, getInfo, iCategory = -1, getCategory = None, bSort = true ):
##--------	More Detailed Civilopedia: End Modify
		' returned a list of infos sorted alphabetically '

##--------	More Detailed Civilopedia: Modified by Denev 2009/09/19
		"""
		# count the items we are going to display
		iNumNonGraphical = 0
		for i in range(numInfos):
			if (not getInfo(i).isGraphicalOnly()):
				iNumNonGraphical += 1

		infoList = [(0,0)] * iNumNonGraphical
		j = 0
		for i in range( numInfos ):
			if (not getInfo(i).isGraphicalOnly()):
				infoList[j] = (getInfo(i).getDescription(), i)
				j += 1

		infoList.sort()
		"""
		liItem = []
		for iItemID in range(numInfos):
			if getInfo(iItemID):
				if ((None in (iCategory, getCategory) or getCategory(iItemID) == iCategory) and not getInfo(iItemID).isGraphicalOnly()):
					szDescription = getInfo(iItemID).getDescription()
					try:
						szPronunciation = getInfo(iItemID).getPronunciation()
					except AttributeError:
						szPronunciation = ""
					if szPronunciation != "":
						liItem.append( (szPronunciation, iItemID, szDescription) )
					else:
						if szDescription[0:4] == "The ":
							liItem.append( (szDescription[4:], iItemID, szDescription) )
						else:
							liItem.append( (szDescription, iItemID, szDescription) )
		if bSort:
			liItem.sort()
##--------	More Detailed Civilopedia: End Modify

		return liItem


##--------	More Detailed Civilopedia: Added by Denev 2009/09/25
	def getListBuildingCivilization(self, iBuilding):
		if iBuilding == BuildingTypes.NO_BUILDING:
			return []

		liAvailableCiv = []
		if gc.getBuildingInfo(iBuilding).getPrereqCiv() != CivilizationTypes.NO_CIVILIZATION:
			liAvailableCiv.append(gc.getBuildingInfo(iBuilding).getPrereqCiv())
		else:
			iBuildingClass = gc.getBuildingInfo(iBuilding).getBuildingClassType()
			for iCiv in range(gc.getNumCivilizationInfos()):
				iUniqueBuilding = gc.getCivilizationInfo(iCiv).getCivilizationBuildings(iBuildingClass)
				if iUniqueBuilding == iBuilding:
					liAvailableCiv.append(iCiv)

		return liAvailableCiv


	def getListUnitCivilization(self, iUnit):
		if iUnit == UnitTypes.NO_UNIT:
			return []

		liAvailableCiv = []
		if gc.getUnitInfo(iUnit).getPrereqCiv() != CivilizationTypes.NO_CIVILIZATION:
			liAvailableCiv.append(gc.getUnitInfo(iUnit).getPrereqCiv())
		else:
			iUnitClass = gc.getUnitInfo(iUnit).getUnitClassType()
			for iCiv in range(gc.getNumCivilizationInfos()):
				iUniqueUnit = gc.getCivilizationInfo(iCiv).getCivilizationUnits(iUnitClass)
				if iUniqueUnit == iUnit:
					liAvailableCiv.append(iCiv)

		return liAvailableCiv


	def getListTrainableBuilding(self, iBuildingClass, iUnit):
		if iBuildingClass == BuildingClassTypes.NO_BUILDINGCLASS:
			return []

		liAvailableBuilding = []
		for iCiv in self.getListUnitCivilization(iUnit):
			iAvailableBuilding = gc.getCivilizationInfo(iCiv).getCivilizationBuildings(iBuildingClass)
			liAvailableBuilding.append(iAvailableBuilding)
		liAvailableBuilding = sorted(set(liAvailableBuilding), key=liAvailableBuilding.index)	#remove repeated items

		return liAvailableBuilding


	def pickLeaderCiv(self, iLeader):
		liLeaderCiv = []
		iLeaderCiv = CivilizationTypes.NO_CIVILIZATION
		for iCiv in range(gc.getNumCivilizationInfos()):
			pCiv = gc.getCivilizationInfo(iCiv)
			if pCiv.isLeaders(iLeader):
				liLeaderCiv.append(iCiv)
		if len(liLeaderCiv) > 0:
			iLeaderCiv = random.choice(liLeaderCiv)

		return iLeaderCiv
##--------	More Detailed Civilopedia: End Added
