## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
from CvPythonExtensions import *
import CvUtil
import CvPediaScreen
import ScreenInput
import CvScreenEnums
##--------	More Detailed Civilopedia: Added by Denev 2009/11/04
import CvTechUtil
##--------	More Detailed Civilopedia: End Add

# globals
gc = CyGlobalContext()
ArtFileMgr = CyArtFileMgr()
localText = CyTranslator()

class CvPediaTech(CvPediaScreen.CvPediaScreen):
	"Civilopedia Screen for Techs"

	def __init__(self, main):
		self.iTech = -1
		self.top = main

##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
		"""
		self.X_TECH_PANE = 20
		self.Y_TECH_PANE = 70
		self.W_TECH_PANE = 368
		self.H_TECH_PANE = 210

		self.X_ICON = 48
		self.Y_ICON = 105
		self.W_ICON = 150
		self.H_ICON = 150
		self.ICON_SIZE = 64

		self.X_COST = 200
		self.Y_COST = 165

		self.BUTTON_SIZE = 64

		self.X_QUOTE_PANE = 410
		self.Y_QUOTE_PANE = 70
		self.W_QUOTE_PANE = 368
		self.H_QUOTE_PANE = 210

		self.X_UNIT_PANE = 410
		self.Y_UNIT_PANE = 430
		self.W_UNIT_PANE = 368
		self.H_UNIT_PANE = 124

		self.X_BUILDING_PANE = 410
		self.Y_BUILDING_PANE = 568
		self.W_BUILDING_PANE = 368
		self.H_BUILDING_PANE = 124

		self.X_PREREQ_PANE = 20
		self.Y_PREREQ_PANE = 292
		self.W_PREREQ_PANE = 368
		self.H_PREREQ_PANE = 124

		self.X_LEADS_TO_PANE = 410
		self.Y_LEADS_TO_PANE = 292
		self.W_LEADS_TO_PANE = 368
		self.H_LEADS_TO_PANE = 124

		self.X_SPECIAL_PANE = 20
		self.Y_SPECIAL_PANE = 430
		self.W_SPECIAL_PANE = 368
		self.H_SPECIAL_PANE = 262
		"""
		X_MERGIN = self.top.X_MERGIN
		Y_MERGIN = self.top.Y_MERGIN

		self.X_TECH_PANE = self.top.X_PEDIA_PAGE
		self.Y_TECH_PANE = self.top.Y_PEDIA_PAGE
		self.W_TECH_PANE = 368
		self.H_TECH_PANE = 210

		self.W_ICON = 150
		self.H_ICON = 150
		self.X_ICON = self.X_TECH_PANE + (self.H_TECH_PANE - self.H_ICON) / 2
		self.Y_ICON = self.Y_TECH_PANE + (self.H_TECH_PANE - self.H_ICON) / 2
		self.ICON_SIZE = 64

		self.X_STATUS = self.X_ICON + self.W_ICON + 10
		self.Y_STATUS = self.Y_ICON + 50
		self.W_STATUS = self.X_TECH_PANE + self.W_TECH_PANE - self.X_STATUS
		self.H_STATUS = self.Y_TECH_PANE + self.H_TECH_PANE - self.Y_STATUS

		self.H_LEADS_TO_PANE = 110
		self.X_LEADS_TO_PANE = self.X_TECH_PANE + self.W_TECH_PANE + X_MERGIN
		self.Y_LEADS_TO_PANE = self.Y_TECH_PANE + self.H_TECH_PANE - self.H_LEADS_TO_PANE
		self.W_LEADS_TO_PANE = self.top.R_PEDIA_PAGE - self.X_LEADS_TO_PANE

		self.H_PREREQ_PANE = 110
		self.X_PREREQ_PANE = self.X_LEADS_TO_PANE
		self.Y_PREREQ_PANE = self.Y_LEADS_TO_PANE - self.H_PREREQ_PANE - Y_MERGIN
		self.W_PREREQ_PANE = self.W_LEADS_TO_PANE

		self.X_BUILDING_PANE = self.X_TECH_PANE
		self.Y_BUILDING_PANE = self.Y_TECH_PANE + self.H_TECH_PANE + Y_MERGIN
		self.W_BUILDING_PANE = self.W_TECH_PANE
		self.H_BUILDING_PANE = 110

		self.X_UNIT_PANE = self.X_BUILDING_PANE + self.W_BUILDING_PANE + X_MERGIN
		self.Y_UNIT_PANE = self.Y_BUILDING_PANE
		self.W_UNIT_PANE = self.top.R_PEDIA_PAGE - self.X_UNIT_PANE
		self.H_UNIT_PANE = self.H_BUILDING_PANE

		self.X_OTHER_PANE = self.X_BUILDING_PANE
		self.Y_OTHER_PANE = self.Y_BUILDING_PANE + self.H_BUILDING_PANE + Y_MERGIN
		self.W_OTHER_PANE = self.W_BUILDING_PANE
		self.H_OTHER_PANE = 110

		self.X_SPECIAL_PANE = self.X_OTHER_PANE
		self.Y_SPECIAL_PANE = self.Y_OTHER_PANE + self.H_OTHER_PANE + Y_MERGIN
		self.W_SPECIAL_PANE = self.W_OTHER_PANE
		self.H_SPECIAL_PANE = self.top.B_PEDIA_PAGE - self.Y_SPECIAL_PANE

		self.X_QUOTE_PANE = self.X_UNIT_PANE
		self.Y_QUOTE_PANE = self.Y_UNIT_PANE + self.H_UNIT_PANE + Y_MERGIN
		self.W_QUOTE_PANE = self.W_UNIT_PANE
		self.H_QUOTE_PANE = self.top.B_PEDIA_PAGE - self.Y_QUOTE_PANE
##--------	More Detailed Civilopedia: End Modify

	def interfaceScreen(self, iTech):

		self.iTech = iTech

		self.top.deleteAllWidgets()

		screen = self.top.getScreen()

		bNotActive = (not screen.isActive())
		if bNotActive:
			self.top.setPediaCommonWidgets()

		# Header...
		szHeader = u"<font=4b>" + gc.getTechInfo(self.iTech).getDescription().upper() + u"</font>"
		screen.setLabel(self.top.getNextWidgetName(), "Background", szHeader, CvUtil.FONT_CENTER_JUSTIFY, self.top.X_SCREEN, self.top.Y_TITLE, 0, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_GENERAL, CivilopediaPageTypes.CIVILOPEDIA_PAGE_TECH, iTech)

		# Top
		screen.setText(self.top.getNextWidgetName(), "Background", self.top.MENU_TEXT, CvUtil.FONT_LEFT_JUSTIFY, self.top.X_MENU, self.top.Y_MENU, 0, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_PEDIA_MAIN, CivilopediaPageTypes.CIVILOPEDIA_PAGE_TECH, -1)

		if self.top.iLastScreen	!= CvScreenEnums.PEDIA_TECH or bNotActive:
			self.placeLinks(true)
			self.top.iLastScreen = CvScreenEnums.PEDIA_TECH
		else:
			self.placeLinks(false)

		screen.addPanel( self.top.getNextWidgetName(), "", "", False, False, self.X_TECH_PANE, self.Y_TECH_PANE, self.W_TECH_PANE, self.H_TECH_PANE, PanelStyles.PANEL_STYLE_BLUE50)

		# Icon
		screen.addPanel(self.top.getNextWidgetName(), "", "", false, false, self.X_ICON, self.Y_ICON, self.W_ICON, self.H_ICON, PanelStyles.PANEL_STYLE_MAIN)
		screen.addDDSGFC(self.top.getNextWidgetName(), gc.getTechInfo(self.iTech).getButton(), self.X_ICON + self.W_ICON/2 - self.ICON_SIZE/2, self.Y_ICON + self.H_ICON/2 - self.ICON_SIZE/2, self.ICON_SIZE, self.ICON_SIZE, WidgetTypes.WIDGET_GENERAL, -1, -1 )

##--------	More Detailed Civilopedia: Deleted by Denev 2009/09/24
		"""
		szCostId = self.top.getNextWidgetName()
		if self.top.iActivePlayer == -1:
			szCostText = localText.getText("TXT_KEY_PEDIA_COST", ( gc.getTechInfo(iTech).getResearchCost(), ) ) + u"%c" % (gc.getCommerceInfo(CommerceTypes.COMMERCE_RESEARCH).getChar())
		else:
			szCostText = localText.getText("TXT_KEY_PEDIA_COST", ( gc.getTeam(gc.getGame().getActiveTeam()).getResearchCost(iTech), ) ) + u"%c" % (gc.getCommerceInfo(CommerceTypes.COMMERCE_RESEARCH).getChar())
		screen.setLabel(szCostId, "Background", u"<font=4>" + szCostText.upper() + u"</font>", CvUtil.FONT_LEFT_JUSTIFY, self.X_COST + 25, self.Y_COST, 0, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1)
		"""
##--------	More Detailed Civilopedia: End Delete

		# Place Required techs
		self.placePrereqs()

		# Place Allowing techs
		self.placeLeadsTo()

		# Place Units
		self.placeUnits()

		# Place buildings
		self.placeBuildings()

		# Place the Special abilities block
		self.placeSpecial()

		# Place the quote for this technology
		self.placeQuote()

##--------	More Detailed Civilopedia: Added by Denev 2009/09/24
		self.placeStats()

		self.placeOthers()


	def placeStats(self):
		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addListBoxGFC(panelName, "", self.X_STATUS, self.Y_STATUS, self.W_STATUS, self.H_STATUS, TableStyles.TABLE_STYLE_EMPTY)
		screen.enableSelect(panelName, False)

		if gc.getTechInfo(self.iTech).getResearchCost() < 0:
			szCostText = localText.getText("TXT_KEY_PEDIA_UNRESEARCHABLE", ())
		elif self.top.iActivePlayer == -1:
			szCostText = localText.getText("TXT_KEY_PEDIA_COST", ( gc.getTechInfo(self.iTech).getResearchCost(), ) ) + u"%c" % (gc.getCommerceInfo(CommerceTypes.COMMERCE_RESEARCH).getChar())
		else:
			szCostText = localText.getText("TXT_KEY_PEDIA_COST", ( gc.getTeam(gc.getGame().getActiveTeam()).getResearchCost(self.iTech), ) ) + u"%c" % (gc.getCommerceInfo(CommerceTypes.COMMERCE_RESEARCH).getChar())
		szCostText = u"<font=4>" + szCostText.upper() + u"</font>"
		screen.appendListBoxString(panelName, szCostText, WidgetTypes.WIDGET_GENERAL, 0, 0, CvUtil.FONT_LEFT_JUSTIFY)
##--------	More Detailed Civilopedia: End Add


	# Place prereqs...
	def placeLeadsTo(self):

		screen = self.top.getScreen()

		# add pane and text
		szLeadsTo = localText.getText("TXT_KEY_PEDIA_LEADS_TO", ())

		panelName = self.top.getNextWidgetName()
		screen.addPanel(panelName, szLeadsTo, "", false, true, self.X_LEADS_TO_PANE, self.Y_LEADS_TO_PANE, self.W_LEADS_TO_PANE, self.H_LEADS_TO_PANE, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		for j in range(gc.getNumTechInfos()):
			for k in range(gc.getNUM_OR_TECH_PREREQS()):
				iPrereq = gc.getTechInfo(j).getPrereqOrTechs(k)
				if (iPrereq == self.iTech):
						screen.attachImageButton( panelName, "", gc.getTechInfo(j).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_DERIVED_TECH, j, self.iTech, False )
			for k in range(gc.getNUM_AND_TECH_PREREQS()):
				iPrereq = gc.getTechInfo(j).getPrereqAndTechs(k)
				if (iPrereq == self.iTech):
						screen.attachImageButton( panelName, "", gc.getTechInfo(j).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_DERIVED_TECH, j, self.iTech, False )

	# Place prereqs...
	def placePrereqs(self):

		screen = self.top.getScreen()

		szRequires = localText.getText("TXT_KEY_PEDIA_REQUIRES", ())

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, szRequires, "", false, true, self.X_PREREQ_PANE, self.Y_PREREQ_PANE, self.W_PREREQ_PANE, self.H_PREREQ_PANE, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		bFirst = True
		for j in range(gc.getNUM_AND_TECH_PREREQS()):
			eTech = gc.getTechInfo(self.iTech).getPrereqAndTechs(j)
			if (eTech > -1):
				if (not bFirst):
					screen.attachLabel(panelName, "", localText.getText("TXT_KEY_AND", ()))
				else:
					bFirst = False
				screen.attachImageButton( panelName, "", gc.getTechInfo(eTech).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_REQUIRED_TECH, eTech, j, False )

		# count the number of OR techs
		nOrTechs = 0
		for j in range(gc.getNUM_OR_TECH_PREREQS()):
			if (gc.getTechInfo(self.iTech).getPrereqOrTechs(j) > -1):
				nOrTechs += 1

		szLeftDelimeter = ""
		szRightDelimeter = ""
		#  Display a bracket if we have more than one OR tech and at least one AND tech
		if (not bFirst):
			if (nOrTechs > 1):
				szLeftDelimeter = localText.getText("TXT_KEY_AND", ()) + "( "
				szRightDelimeter = " ) "
			elif (nOrTechs > 0):
				szLeftDelimeter = localText.getText("TXT_KEY_AND", ())
			else:
				return

		if len(szLeftDelimeter) > 0:
			screen.attachLabel(panelName, "", szLeftDelimeter)

		bFirst = True
		for j in range(gc.getNUM_OR_TECH_PREREQS()):
			eTech = gc.getTechInfo(self.iTech).getPrereqOrTechs(j)
			if (eTech > -1):
				if (not bFirst):
					screen.attachLabel(panelName, "", localText.getText("TXT_KEY_OR", ()))
				else:
					bFirst = False
				screen.attachImageButton( panelName, "", gc.getTechInfo(eTech).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_REQUIRED_TECH, eTech, j, False )

		if len(szRightDelimeter) > 0:
			screen.attachLabel(panelName, "", szRightDelimeter)

##--------	More Detailed Civilopedia: Added by Denev 2009/09/23
		"State Religion Prereq"
		iReligion = gc.getTechInfo(self.iTech).getPrereqReligion()
		if iReligion != ReligionTypes.NO_RELIGION:
			screen.attachLabel(panelName, "", localText.getText("TXT_KEY_AND", ()))
			screen.attachImageButton( panelName, "", gc.getReligionInfo(iReligion).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_RELIGION, iReligion, 1, False )
##--------	More Detailed Civilopedia: End Add


	# Place units...
	def placeUnits(self):

		screen = self.top.getScreen()
		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_UNITS_ENABLED", ()), "", false, true, self.X_UNIT_PANE, self.Y_UNIT_PANE, self.W_UNIT_PANE, self.H_UNIT_PANE, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

##--------	More Detailed Civilopedia: Modified by Denev 2009/11/04
		"""
		for eLoopUnit in range(gc.getNumUnitInfos()):
			if (eLoopUnit != -1):
				if (isTechRequiredForUnit(self.iTech, eLoopUnit)):
					szButton = gc.getUnitInfo(eLoopUnit).getButton()
					if self.top.iActivePlayer != -1:
						szButton = gc.getPlayer(self.top.iActivePlayer).getUnitButton(eLoopUnit)
					screen.attachImageButton( panelName, "", szButton, GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_UNIT, eLoopUnit, 1, False )
		"""
		CvTechUtil.placeUnitsContents(screen, panelName, self.iTech)
##--------	More Detailed Civilopedia: End Modify

	# Place buildings...
	def placeBuildings(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_BUILDINGS_ENABLED", ()), "", false, true, self.X_BUILDING_PANE, self.Y_BUILDING_PANE, self.W_BUILDING_PANE, self.H_BUILDING_PANE, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

##--------	More Detailed Civilopedia: Modified by Denev 2009/11/04
		"""
		for eLoopBuilding in range(gc.getNumBuildingInfos()):
			if (eLoopBuilding != -1):
				if (isTechRequiredForBuilding(self.iTech, eLoopBuilding)):
						screen.attachImageButton( panelName, "", gc.getBuildingInfo(eLoopBuilding).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BUILDING, eLoopBuilding, 1, False )

		for eLoopProject in range(gc.getNumProjectInfos()):
			if (isTechRequiredForProject(self.iTech, eLoopProject)):
					screen.attachImageButton( panelName, "", gc.getProjectInfo(eLoopProject).getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM, WidgetTypes.WIDGET_PEDIA_JUMP_TO_PROJECT, eLoopProject, 1, False )
		"""
		CvTechUtil.placeBuildingsContents(screen, panelName, self.iTech)
##--------	More Detailed Civilopedia: End Modify

##--------	More Detailed Civilopedia: Added by Denev 2009/09/23
	# Place Others...
	def placeOthers(self):
		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_OTHERS_ENABLED", ()), "", false, true, self.X_OTHER_PANE, self.Y_OTHER_PANE, self.W_OTHER_PANE, self.H_OTHER_PANE, PanelStyles.PANEL_STYLE_BLUE50 )

		screen.attachLabel(panelName, "", "  ")

		CvTechUtil.placeOthersContents(screen, panelName, self.iTech)

	def placeSpecial(self):

		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
		screen.addPanel( panelName, localText.getText("TXT_KEY_PEDIA_SPECIAL_ABILITIES", ()), "", true, false, self.X_SPECIAL_PANE, self.Y_SPECIAL_PANE, self.W_SPECIAL_PANE, self.H_SPECIAL_PANE, PanelStyles.PANEL_STYLE_BLUE50 )

		listName = self.top.getNextWidgetName()

		szSpecialText = CyGameTextMgr().getTechHelp(self.iTech, True, False, False, False, -1)[1:]
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/18
#		screen.addMultilineText(listName, szSpecialText, self.X_SPECIAL_PANE+5, self.Y_SPECIAL_PANE+30, self.W_SPECIAL_PANE-35, self.H_SPECIAL_PANE-10, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
		screen.addMultilineText(listName, szSpecialText, self.X_SPECIAL_PANE+5, self.Y_SPECIAL_PANE+30, self.W_SPECIAL_PANE-5, self.H_SPECIAL_PANE-32, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
##--------	More Detailed Civilopedia: End Modify


	def placeQuote(self):
		screen = self.top.getScreen()

		panelName = self.top.getNextWidgetName()
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
		"""
		screen.addPanel(panelName, "", "", true, true,
			self.X_QUOTE_PANE, self.Y_QUOTE_PANE, self.W_QUOTE_PANE, self.H_QUOTE_PANE, PanelStyles.PANEL_STYLE_BLUE50)
		"""
		screen.addPanel(panelName, " ", "", true, true,
			self.X_QUOTE_PANE, self.Y_QUOTE_PANE, self.W_QUOTE_PANE, self.H_QUOTE_PANE, PanelStyles.PANEL_STYLE_BLUE50)
##--------	More Detailed Civilopedia: End Modify

		szQuote = gc.getTechInfo(self.iTech).getQuote()

#FfH: Modified by Kael 04/13/2009
#		szQuote += u"\n\n" + gc.getTechInfo(self.iTech).getCivilopedia()
#FfH: End Modify

		szQuoteTextWidget = self.top.getNextWidgetName()
##--------	More Detailed Civilopedia: Modified by Denev 2009/09/23
		"""
		screen.addMultilineText( szQuoteTextWidget, szQuote, self.X_QUOTE_PANE + 15, self.Y_QUOTE_PANE + 15,
			self.W_QUOTE_PANE - (15 * 2), self.H_QUOTE_PANE - (15 * 2), WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
		"""
		screen.addMultilineText( szQuoteTextWidget, szQuote, self.X_QUOTE_PANE + 5, self.Y_QUOTE_PANE + 30,
			self.W_QUOTE_PANE - 5, self.H_QUOTE_PANE - 32, WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
##--------	More Detailed Civilopedia: End Modify

	def placeLinks(self, bRedraw):

		screen = self.top.getScreen()

		if bRedraw:
			screen.clearListBoxGFC(self.top.LIST_ID)

##--------	More Detailed Civilopedia: Modified by Denev 2009/11/06
		"""
		techsList = self.getSortedList( gc.getNumTechInfos(), gc.getTechInfo )

		iSelected = 0
		i = 0
		for iI in range(gc.getNumTechInfos()):
			if (not gc.getTechInfo(techsList[iI][1]).isGraphicalOnly()):
				if bRedraw:
					screen.appendListBoxStringNoUpdate(self.top.LIST_ID, techsList[iI][0], WidgetTypes.WIDGET_PEDIA_JUMP_TO_TECH, techsList[iI][1], 0, CvUtil.FONT_LEFT_JUSTIFY )
				if techsList[iI][1] == self.iTech:
					iSelected = i
				i += 1

		if bRedraw:
			screen.updateListBox(self.top.LIST_ID)
		"""
		listSorted = self.top.getSortedList( gc.getNumTechInfos(), gc.getTechInfo )

		iSelected = 0
		for iIndex, (szIndexName, iTech, szDescription) in enumerate(listSorted):
			if not gc.getTechInfo(iTech).isGraphicalOnly():
				if bRedraw:
					screen.appendListBoxString(self.top.LIST_ID, szDescription, WidgetTypes.WIDGET_PEDIA_JUMP_TO_TECH, iTech, 0, CvUtil.FONT_LEFT_JUSTIFY)
				if iTech == self.iTech:
					iSelected = iIndex
##--------	More Detailed Civilopedia: End Modify

		screen.setSelectedListBoxStringGFC(self.top.LIST_ID, iSelected)

	# Will handle the input for this screen...
	def handleInput (self, inputClass):
		return 0
